package pg.android.activity;

import java.io.IOException;
import pg.android.kernel.Bluetooth;
import pg.android.kernel.Device;
import pg.android.kernel.DeviceContainer;
import pg.android.kernel.Protocol;
import static pg.android.kernel.Protocol.toHexString;
import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class DeviceListActivity extends Activity {
	private ListView listSensor;
	public static ConnectThread connection = null;	
	private DeviceAdapter deviceAdapter = null;
	private ProgressDialog progressDialog = null;
	boolean run = true;
	
    private final BroadcastReceiver broadcastReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();
			
			if (action.equals("VALUECHANGED")) {
				//Logger.add("recieve VALUECHANGED by: " + deviceNumber);
				deviceAdapter.notifyDataSetChanged();
			}
		}
    };
	
	private class ConnectThread extends Thread {		
		boolean isValid = false;
		
	    public void run() {
	        try {
	            Bluetooth.connect();
	    		Logger.add("bluetooth connection successfull");
	    		
	            byte[] buffer = new byte[16];
	            
	            Logger.add("Ping");
	            do {
	            	Logger.add("send: " + toHexString(Protocol.Ping()));
	    	    	Bluetooth.send(Protocol.Ping());
	    	    	
	    	    	Bluetooth.read(buffer);
	    	    	Logger.add("back: " + toHexString(buffer));

	    	    	isValid = Protocol.isPong(buffer);
	    	    	Logger.add("packet is valid: " + isValid);
	            } while (!isValid);

	            Logger.add("GetDeviceCount");
	            final int deviceCount = Bluetooth.readDeviceCount();
	            
	            Logger.add("GetDeviceCount: " + deviceCount);

	            
	            runOnUiThread(new Runnable() {
		            public void run() {
		            	showDialog(1);
		            }
	            });
	            progressDialog.setMax(deviceCount);
  
	            for (int d = 0; d < deviceCount; d++) {
	            	Logger.add("GetDeviceInfo " + d);
		            do {
		    	    	Bluetooth.send(Protocol.GetDeviceInfo(d));
		            	Logger.add("send: " + toHexString(Protocol.GetDeviceInfo(d)));		    	    			    	    	    	    	
		            	Bluetooth.read(buffer);
		    	    	Logger.add("back: " +  toHexString(buffer));
		    	    	
		    	    	isValid = Protocol.isReturnDeviceInfo(buffer, d);
		    	    	Logger.add("packet is valid: " + isValid);
		            } while (!isValid);

		            
		            //neues gert erzeugen 
		            final Device device = Device.parse(buffer);

	            	Logger.add("GetDeviceName: " + d);
	            	device.name = Bluetooth.readName(d);

    	    		//
	            	Logger.add("GetDeviceValue: " + d);
	            	do {
	            		Bluetooth.send(Protocol.GetDeviceValue(d));
	            		Logger.add("send: " + toHexString(Protocol.GetDeviceValue(d)));		            		
	            		Bluetooth.read(buffer);
	            		Logger.add("back: " + toHexString(buffer));	
	            		
	            		isValid = Protocol.isReturnDeviceValue(buffer, d);
		    	    	Logger.add("packet is valid: " + isValid);
	            	} while (!isValid);

	            	device.setValue(buffer[5], buffer[6]);

	            	//neues Gert hinzufgen
		            runOnUiThread(new Runnable() {
		                public void run() {
		                	DeviceContainer.add(device);
		                	deviceAdapter.notifyDataSetChanged();
		                	listSensor.refreshDrawableState();
		                }
		            });
		            
		            
		            
		            
		            progressDialog.setProgress(d);
	            }
	            
	            progressDialog.dismiss();	
	            
	            do {
	            for (int d = 0; d < deviceCount; d++) {
	            	if (Bluetooth.getValuePacketToSend == true){
	    	           // do {
	    	            	Logger.add("FFsend: " + toHexString(Bluetooth.getValuePacket));
	    	    	    	Bluetooth.send(Bluetooth.getValuePacket);
	    	    	    	
	    	    	    	Bluetooth.read(buffer);
	    	    	    	Logger.add("back: " + toHexString(buffer));

	    	    	    //	Logger.add("packet is valid: " + Protocol.isAckDeviceValue(buffer, nummer));						    	    	
	    	           // } while (!Protocol.isAckDeviceValue(buffer, nummer));
	    	    	    	Bluetooth.getValuePacketToSend = false;
	            	}
	            	
	            	
	            	Device device = DeviceContainer.get(d);			            	
					
	            		Bluetooth.send(Protocol.GetDeviceValue(d));
	            		//Logger.add("send: " + toHexString(Protocol.GetDeviceValue(d)));		            		
	            		Bluetooth.read(buffer);
	            		//Logger.add("back: " + toHexString(buffer));	
	            		
	            		isValid = Protocol.isReturnDeviceValue(buffer, d);
		    	    	Logger.add("packet is valid: " + isValid);

	            	device.setValue(buffer[5], buffer[6]);
	            	Intent intent = new Intent("VALUECHANGED");
					intent.putExtra("DeviceNumber", device.number);
						
					sendBroadcast(intent);

	            }
	            } while (run == true);
	            
	        } catch (IOException connectException) {	
	        	Logger.add("bt error: " + connectException.getMessage());

	            // Unable to connect; close the socket and get out
	            try {
	                Bluetooth.disconnect();
	            } catch (IOException closeException) {
		        	Logger.add("bt error: " + connectException.getMessage());
	            }
	           
	            return;
	        }
	        
	        Logger.add("complete");
	    }	 
	}	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.devicelistactivitylayout);
		

		TextView textName = (TextView)findViewById(R.id.textName);
		textName.setText("Name: " + Bluetooth.device.getName());
		TextView textMAC = (TextView)findViewById(R.id.textMAC);
		textMAC.setText("MAC: " + Bluetooth.device.getAddress());
		TextView textBTClass = (TextView)findViewById(R.id.textBTClass);
		textBTClass.setText("BTClass: " + Bluetooth.device.getBluetoothClass());
		TextView textBondState = (TextView)findViewById(R.id.textBondState);
		textBondState.setText("BondState: " + Bluetooth.device.getBondState());

		//
		deviceAdapter = new DeviceAdapter(this, R.layout.deviceview_item, DeviceContainer.getAll());
		
		listSensor = (ListView)findViewById(R.id.listSensor);

        TextView header = (TextView)getLayoutInflater().inflate(R.layout.listheader, null);
        header.setText(R.string.connected_sensors);
        // Deaktivieren damit man nicht auf header drcken kann
        header.setEnabled(false);
        listSensor.addHeaderView(header);

		listSensor.setAdapter(deviceAdapter);

		listSensor.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				Intent in = null;

				//nur auf Elemente in der Liste reagieren
				if (view.isEnabled()){
					switch (deviceAdapter.getItem(position - 1).getType()){
					case Protocol.DeviceType.Sensor:
						in = new Intent(DeviceListActivity.this, SensorActivity.class);
						in.putExtra("DeviceNummer", position - 1);
						startActivity(in);					
						break;
					case Protocol.DeviceType.Aktor:
						in = new Intent(DeviceListActivity.this, AktorActivity.class);
						in.putExtra("DeviceNummer", position - 1);
						startActivity(in);					
						break;
					}					
				}
			}
		});	
		
		progressDialog = new ProgressDialog(this);
		
		registerReceiver(broadcastReceiver,new IntentFilter("VALUECHANGED")); 
		
		connection = new ConnectThread();
		if (connection == null) {
	        Toast.makeText(getApplicationContext(), "Interner Fehler ist aufgetretten.", Toast.LENGTH_SHORT).show();
	
			finish();
		}
		
		connection.start();
	}
	
	
	
    /**
     * Menu erzeugen
     */
	/*
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.logger, menu);
        
        return true;
    }
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
        
        case R.id.logger:
			Intent in = new Intent(DeviceListActivity.this, Logger.class);
			startActivity(in);
        	
        	return true;
        default:
            return super.onOptionsItemSelected(item);
        }
    }
*/
	
	
	@Override
	protected void onDestroy() {
		connection.interrupt();
    	try {
			Bluetooth.disconnect();//TODO
		} catch (IOException e) {
			
			Logger.add("<error> " + e);
		}
		deviceAdapter.clear();
		
		unregisterReceiver(broadcastReceiver);	//BroadcastReceiver unregistrieren
		super.onDestroy();
	}
	
	@Override
	protected Dialog onCreateDialog(int id) {
        progressDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
        progressDialog.setMessage(getResources().getString(R.string.read_data));
        progressDialog.setCancelable(true);
        
        return progressDialog;
	}
}
